import math

""" Algorithmen und Programmieren II (SS 2012)
    Lösungen zum 1. Übungsblatt
    
    1. Aufgabe
"""

def RGB_2_CMYK (red, green, blue):
    """Berechnet die CMYK-Kodierung nach Eingabe einer RGB-Kodierung."""
    
    if (red, green, blue) == (0, 0, 0):
        return (0, 0, 0, 1)
    else:
        w = max (red/255, green/255, blue/255)
        cyan = (w - (red / 255)) / w
        magenta = (w - (green / 255)) / w
        yellow  = (w - (blue / 255)) / w
        black   = 1 - w
        return (cyan, magenta, yellow, black)
    
def test_RGB_2_CMYK ():
    """Die RGB_2_CMYK-Funktion wird mit verschiedenen RGB-Werten getestet"""
    
    print( RGB_2_CMYK (0, 0, 0) )       # entspricht Schwarz         = (0,0,0,1)
    print( RGB_2_CMYK (0, 255, 255) )   # Grün + Blau ergibt Cyan    = (1,0,0,0)
    print( RGB_2_CMYK (255, 0, 255) )   # Rot  + Blau ergibt Magenta = (0,1,0,0)
    print( RGB_2_CMYK (255, 255, 0) )   # Rot  + Grün ergibt Gelb    = (0,0,1,0)
    print( RGB_2_CMYK (250, 250, 250) ) # Weiss = (0,0,0,0)
    print( RGB_2_CMYK (128, 128, 128) ) # Grau = (0,0,0,0.5)
    print( RGB_2_CMYK (0, 0, 255) )     # Blau = (1,1,0,0) 



""" 2. Aufgabe """

def mersenne (n):
    """Berechnet die n-te Mersenne-Zahl ohne Zuhilfe-Name
       des Power-Operators."""

    zahl = 1
    for i in range(n):    # Es war ausdrücklich gefordert,
        zahl = zahl * 2   # eine Schleife zu verwenden.

    return zahl - 1

def test_mersenne ():
    """Prüft 5 mit unserer Funktion generierte Mersenne-Zahlen
       gegen 5 mit dem Power-Operator generierten Zahlen."""
    
    for i in range(5):
        meine_zahl     = mersenne (i)
        """ Beim Testen wird der Power-Operator verwendet """
        erwartete_zahl = 2 ** i - 1
        print ( i                    
              , meine_zahl      
              , erwartete_zahl
              , meine_zahl == erwartete_zahl
              )



""" 3. Aufgabe """

def pi (n):
    """Berechnet eine Annäherung von Pi mit Hilfe folgender Reihe:
       (pi*pi)/6 = 1 + 1/(2*2) + 1/(3*3) + 1/4*4) + ... + 1/(n*n) """

    summe = 0
    for i in range(1, n + 1):
        summe = summe + 1/(i*i)
    
    return math.sqrt(summe*6)

def test_pi ():
    best_accuracy = 0
    for i in range (1, 10000, 100):   # Nachvollziehen der Test-Funktion:
        accuracy = pi (i) / math.pi   # left as an exercise to the reader
        if accuracy < best_accuracy:
            print ("Nähert sich nicht Pi an!")
            return
        best_accuracy = accuracy
    print ("Nähert sich Pi an: ", pi(10000))
    


""" 4. Aufgabe """

def dec_2_bin (num, wsize):
    
    """
       Wandelt eine Dezimalzahl in Zweierkomplement-Darstellung
       mit der angegebenen Speichertwortlänge in bits an.

       Das Ergebnis wird als Zeichenkette (string) zurückgegeben.

       Gibt den leeren String zurück, wenn die Zahl in der
       gewählten Speicherwortlänge nicht darstellbar ist.

       Weil wir mit einer unbalancierten Teilung des Zahlenraums zwischen
       negativen und positiven Zahlen zu tun haben (Siehe Vorlesungsfolien),
       müssen die Grenzwerte mit >= und < gegenüber 2**(wsize-1) geprüft
       werden.

    """

    bits = "" # wir starten mit einem leeren String

    # Hier wird der im wsize darstellbare Wertebereich geprüft
    if num >= 2**(wsize-1) or num<-2**(wsize-1): 
        return ""
    
    """ In der Schleife wird geprüft, ob das rechteste Bit 0 oder 1 ist 
        und das Ergebnis (0 oder 1) in bits verkettet. Danach werden alle Bits um
        eine Position nach rechts verschoben.
    """       
    for i in range( 0, wsize ):
        bits = str((num >> i) % 2) + bits
    return bits


def test_dec_2_bin ():
    """Prüft alle Werte mit 3 Bits gegen dec_2_bin
       (und ein paar weitere)."""

    def test (zahl, wsize, erwartet):
        """Führt eine einzelne Überprüfung durch."""

        twos_complement = dec_2_bin (zahl, wsize)
        print ( zahl
              , wsize
              , erwartet
              , twos_complement
              , erwartet == twos_complement
              )

    test (-5, 3, "")
    test (-4, 3, "100") 
    test (-3, 3, "101")
    test (-2, 3, "110")
    test (-1, 3, "111")
    test ( 0, 3, "000")
    test ( 1, 3, "001")
    test ( 2, 3, "010")
    test ( 3, 3, "011")
    test ( 4, 3, "")
    test ( 5, 3, "")

    for i in range(2, 33):
        """0 sollte immer eine Reihe von i Nullen sein."""
        test (0, i, "0" * i) # "x" * n wiederholt "x" n-mal

    for i in range(2, 33):
        """-1 ist immer eine Reihe von i Einsen."""
        test (-1, i, "1" * i)

    for i in range(2, 33):
        """1 ist immer eine Reihe von Nullen bis
           auf die letzte Stelle (dort ist eine Eins)"""
        test (1, i, ("0" * (i-1)) + "1")


def test_alle_Aufgaben():
    print("1. Aufgabe")
    test_RGB_2_CMYK ()
    print("2. Aufgabe")
    test_mersenne()
    print("3. Aufgabe")
    test_pi()
    print("4. Aufgabe")
    test_dec_2_bin()
